/********************************************************/
/*  File Directory Class member functions               */
/*                                                      */
/*------------------------------------------------------*/
/* Basically, a wrapper class for the DosFind APIs      */
/* to provide class access to directory searches        */
/********************************************************/

#include <istring.hpp>
#include <stdlib.h>
#define INCL_WINHELP
#include "fdir.hpp"
#include <os2/os2.h>

//********************************************************
//  Constructor for file directory class                **
//********************************************************

fileDir::fileDir(char *dirPath)
{
  hDirHandle = HDIR_SYSTEM;
  ulFindBufLen = sizeof(FILEFINDBUF3);
  ulFindCount = 1;

  rc = DosFindFirst(dirPath,
                    &hDirHandle,
                    FILE_NORMAL,
                    &findBuf,
                    ulFindBufLen,
                    &ulFindCount,
                    FIL_STANDARD);
  bOpen = (rc == 0);                //indicate open or not
}

//********************************************************
//   Destructor for file directory                      **
//********************************************************

fileDir :: ~fileDir()
{
  dirClose();
}

//********************************************************
//   Fetch next filename                                **
//********************************************************

Boolean fileDir :: dirNext(char *fBuf)
{
  if (ulFindCount)
  {
    strcpy(fBuf, findBuf.achName);
    ulFindCount = 1;
    rc = DosFindNext(hDirHandle,
                     &findBuf,
                     ulFindBufLen,
                     &ulFindCount);
    return true;
   }
    else
       return false;
}

//********************************************************
//   End directory search                               **
//********************************************************

void    fileDir :: dirClose()
{
  if (bOpen)
  {
   rc = DosFindClose(hDirHandle);
   bOpen = false;
  }
}
