/********************************************************/
/*  FNLOGCPM Program                                    */
/********************************************************/


#include <iapp.hpp>
#include <istattxt.hpp>
#include <imenubar.hpp>
#include <ifont.hpp>
#include <istring.hpp>
#include <ifiledlg.hpp>
#include <ilistbox.hpp>
#include <icanvas.hpp>
#include <isetcv.hpp>
#include <isplitcv.hpp>
#include <ipushbut.hpp>
#include <icnrctl.hpp>
#include <icnrobj.hpp>
#include <iprofile.hpp>
#include <fstream.h>
#include <strstrea.h>
#include <itbar.hpp>
#include <itbarbut.hpp>
#include <immamix.hpp>
#include <stdlib.h>
#define INCL_WINHELP
#include "fdir.hpp"
//#include <os2/os2.h>

#include "mltwave.hpp"

#include "mainwnd.hpp"
#include "mainwnd.h"

//*********************************************************
//   Global data definitions                             **
//*********************************************************

char  * pCh1, * pCh2;
char    szMsg[256];
char    szCtrl[64];

//*********************************************************
//   Main application entry point                        **
//*********************************************************

void main(int nArg, char* cArg[])
{
 pCh1 = cArg[0];
 if (nArg > 1)
   pCh2 = cArg[1];

 szMsg[0] = 0;
 AFNLogcWindow mainWindow (ID_MAINWND);
 IApplication::current() .run();
}

//********************************************************
//  Constructor for main window                         **
//********************************************************

AFNLogcWindow :: AFNLogcWindow(unsigned long windowId)
   : IFrameWindow (
     IFrameWindow::defaultStyle()
     | IFrameWindow::minimizedIcon
     | IFrameWindow::accelerator,
     windowId)
  ,AUserMessageHandler( UWM_DONE )
  ,menuBar(windowId, this)
  ,rafProfile("raffle.ini")
  ,itTool1(IT_BAR_FILE, this)
  ,itbOpen(IC_ID_OPEN, &itTool1, &itTool1)
  ,itbSave(IC_ID_SAVE, &itTool1, &itTool1)
  ,itbPrint(IC_ID_PRINT, &itTool1, &itTool1)
  ,isCnv1(ID_CANV1, this, this)
  ,isCnv2(ID_CANV2, &isCnv1, &isCnv1)
  ,cnr1(IDW_CNTNR1, &isCnv2, &isCnv2, IRectangle(),
         IContainerControl::classDefaultStyle |
         IContainerControl::multipleSelection |
         IContainerControl::autoPosition )
  ,cnr2(IDW_CNTNR2, &isCnv2, &isCnv2, IRectangle(),
         IContainerControl::classDefaultStyle |
         IContainerControl::multipleSelection |
         IContainerControl::autoPosition )
  ,isSet1(ID_STCV1, &isCnv1, &isCnv1, IRectangle() )
  ,wavPlayer(0)
{
  isCnv1.setOrientation(ISplitCanvas::horizontalSplit );
  isCnv2.setOrientation(ISplitCanvas::verticalSplit );

  setClient(&isCnv1);

  isCnv1.setSplitWindowPercentage(&isCnv2, 65);
  isCnv1.setSplitWindowPercentage(&isSet1, 25);
  isCnv2.setSplitWindowPercentage(&cnr1,  70);
  isCnv2.setSplitWindowPercentage(&cnr2,  25);

  ((ICommandHandler *) this)->handleEventsFor(this);
  ((AUserMessageHandler *) this)->handleEventsFor(&isSet1);

  itTool1.addAsLast(&itbOpen, true);
  itTool1.addAsLast(&itbSave);
  itTool1.addAsLast(&itbPrint);

  strcpy(logfName, "e:\\per\\");
  bLogOpen = FALSE;
  bCfgFlag = TRUE;
  bTbarFlag = FALSE;
  ASetCfgMenu(bCfgFlag);
  iMixRpt = 4;
  iWinRpt = 3;
  getProfileData();

  bPrFlag = FALSE;
  ASetPrMenu(bPrFlag);

  /* logic for creating MM record panel --------------*/

  try
  {
    wavPlayer = new IMMWaveAudio();
    ampMixer  = new IMMAmpMixer(wavPlayer->connectedDeviceId(IMMDevice::waveStream));
    ampMixer->setCloseOnDestroy(false);
  }
  catch (...)
  {
    wavPlayer = 0;
    ampMixer  = 0;
  }
  aWave = new WAVE (wavPlayer, ID_WAVE1, &isSet1, &isSet1, logfName,
                    UWM_DONE);
  if (!wavPlayer)
    ((IMultiCellCanvas*)aWave)->disable();

  cnr1.setDeleteObjectsOnClose();
  cnr2.setDeleteObjectsOnClose();
  cnr1.showIconView();
  cnr2.showIconView();

  isSet1.setBackgroundColor(IColor(IColor::paleGray));

  show();
  ISize size1 = isCnv1.size();
  ISize size2 = isSet1.minimumSize();
  IRectangle rect1 = rect();
  moveSizeToClient(IRectangle(IPoint(rect1.bottomLeft()),
                              ISize(size2.width(), size1.height())));
//moveSizeToClient(IRectangle(0, 0, size2.width(), size1.height()) );
  setFocus();
}

//********************************************************
//   Destructor for main window                         **
//********************************************************

AFNLogcWindow :: ~AFNLogcWindow()
{
  if (aWave)
    delete  aWave;
  if (wavPlayer)
    delete wavPlayer;
  if (ampMixer)
    delete ampMixer;
}

//********************************************************
//  Command Handler for main window                     **
//********************************************************

Boolean AFNLogcWindow :: command(ICommandEvent & cmdEvent)
{
 unsigned short value;
 unsigned long  ulMid;

 switch (cmdEvent.commandId())
 {
//
//  Cases for "Process" menu item
//
   case IDC1_TBAR:
   {
     if (bTbarFlag)
     {
       menuBar.checkItem(IDC1_TBAR, FALSE);
       bTbarFlag = FALSE;
     }
     else
     {
       menuBar.checkItem(IDC1_TBAR,  TRUE);
       bTbarFlag = TRUE;
     }
     return(true);
     break;
   }

   case IDP_START:
   {
     if (bCfgFlag)
     {
//     AFillCnr();
       bPrFlag = TRUE;
       ASetPrMenu(bPrFlag);
     }
     return(true);
     break;
   }

   case IDP_STOP:
   {
     if (bPrFlag)
     {
       bPrFlag = FALSE;
       ASetPrMenu(bPrFlag);
     }
     return(true);
     break;
   }

   case IDP_REFR:
   {
    char  fName[128];

    strcpy(fName, logfName);
    strcpy(&fName[strlen(fName)], "*.wav");
    fileDir* fDir = new fileDir(fName);
    while (fDir->dirNext(fName))
    {
     fName[strlen(fName)-4] = 0;
     IContainerObject * objNew = new IContainerObject(fName,
      IApplication::current().userResourceLibrary().loadIcon(IDR_ICON1) );
     cnr1.addObject(objNew);
    }
    fDir->dirClose();
    delete fDir;

    return(true);
    break;
   }

   case IDP_WINNER:
   {
    long unsigned ulCt = cnr1.objectCount();   //# of objects

    if (ulCt > 0)
    {
      AShuffleCnr(iWinRpt);
      svObj = cnr1.objectAt( (unsigned long) (rand() % ulCt) );
      cnr1.removeObject(svObj);
      cnr2.addObject(svObj);
      announceWinner(svObj);
    }
    return(true);
    break;
   }

   case IDP_MIX:
   {
    AShuffleCnr(iMixRpt);
    return(true);
    break;
   }

   case IDP_ALLWIN:
   {
    IContainerControl::ObjectCursor * cursor =
            new IContainerControl::ObjectCursor(cnr2);

    for (cursor->setToFirst();
         cursor->isValid();
         cursor->setToNext() )
      {
        svObj = cursor->current();
        announceWinner(svObj);
      }

    delete cursor;
    return(true);
    break;
   }

   case IDP_RESET:
   {
    IContainerControl::ObjectCursor * cursor =
            new IContainerControl::ObjectCursor(cnr2);

    for (cursor->setToFirst();
         cursor->isValid();
         cursor->setToNext() )
      {
        svObj = cursor->current();
        cnr1.addObject(svObj);
      }
    cnr2.removeAllObjects();

    delete cursor;
    return(true);
    break;
   }

//  Cases for Process sub menu items
//
   case IDC1_EXIT:
   case ID_EXITPROGRAM:
   case IDW_DONE:
    {close();
     return(true);
     break;}

/* case IDH1_HELPABOUT:
    {
     aboutDialog->showModally();
     delete aboutDialog;
     return(true);
     break;
    }
*/
 }

 return(false);
}

void AFNLogcWindow :: ASetCfgMenu(BOOL bFlag)
{
  menuBar.checkItem(IDC1_TBAR,  FALSE);
}

void AFNLogcWindow :: ASetPrMenu(BOOL bFlag)
{
  menuBar.enableItem(IDP_START, !bFlag);
  menuBar.enableItem(IDP_STOP, bFlag);
  menuBar.enableItem(IDP_REFR,   bFlag);
  menuBar.enableItem(IDP_WINNER, bFlag);
  menuBar.enableItem(IDP_ALLWIN, bFlag);
  menuBar.enableItem(IDP_RESET,  bFlag);
  menuBar.enableItem(IDP_MIX,    bFlag);
}

void AFNLogcWindow::AAddObject(char * oTitle)
{
  IContainerObject *objNew = new IContainerObject(oTitle,
   IApplication::current().userResourceLibrary().loadIcon(IDR_ICON1));
  cnr1.addObject(objNew);
}

void AFNLogcWindow::AFillCnr()
{
  /* logic for filling container ---------------------*/

  IContainerObject * obj1 = new IContainerObject("Test",
   IApplication::current().userResourceLibrary().loadIcon(IDR_ICON1) );
  IContainerObject * obj2 = new IContainerObject("Test2",
   IApplication::current().userResourceLibrary().loadIcon(IDR_ICON1) );
  IContainerObject * obj3 = new IContainerObject("Test3",
   IApplication::current().userResourceLibrary().loadIcon(IDR_ICON1) );
  svObj = obj3;

  cnr1.addObject(obj1);
  cnr1.addObject(obj2);
  cnr1.addObject(obj3);

  /*  end of container logic -------------------------*/
  return;
}

IBase::Boolean AFNLogcWindow::userMessage(IEvent& evt)
{
  unsigned long param1 = evt.parameter1();

  IContainerObject * obj1 = new IContainerObject("P"+IString(param1),
   IApplication::current().userResourceLibrary().loadIcon(IDR_ICON1) );
  cnr1.addObject(obj1);
  return true;
}

void AFNLogcWindow::AShuffleCnr(int iTimes)
{
 long unsigned ulCt = cnr1.objectCount();   //# of objects
 int           iMixer = 0, x1;

 if (ulCt > 0)
    for (x1=0; x1< iTimes*ulCt; x1++)
    {
     iMixer = rand() % ulCt;
     if (iMixer)
     {
      svObj = cnr1.objectAt( 0L );
      cnr1.moveObjectTo(svObj, 0, 0, cnr1.objectAt( iMixer ) );
      }
    }
}

void AFNLogcWindow::getProfileData( )
{
   IString isApp("Raffle");
   IString isKey1("EntryDirectory");
   IString isKey2("MixRepeat");
   IString isKey3("WinRepeat");

   if ( rafProfile.containsApplication( isApp ) )
   {
     strcpy(logfName, rafProfile.elementWithKey(isKey1,
                                                isApp).asString() );
     iMixRpt = rafProfile.integerWithKey(isKey2, isApp);
     iWinRpt = rafProfile.integerWithKey(isKey3, isApp);
     return;
   }

   rafProfile.addOrReplaceElementWithKey(isKey1,
                                         IString(logfName),
                                         isApp);
   rafProfile.addOrReplaceElementWithKey(isKey2,
                                         (long) iMixRpt,
                                         isApp);
   rafProfile.addOrReplaceElementWithKey(isKey3,
                                         (long) iWinRpt,
                                         isApp);
   return;
}

void AFNLogcWindow::announceWinner(IContainerObject * winObj)
{
      aWave->wavePlayer()->loadOnThread( IString(logfName)
                                          + winObj->iconText()
                                          + ".WAV",
                                         true );
      aWave->playableDevice()->play();
}
