/*---------Class definitions for FNLog PM program-----------*/

#include <icmdhdr.hpp>         //ICommand headers
#include <ifiledlg.hpp>        //IFileDlg headers
#include <fstream.h>
#include <os2/os2.h>

class    IPushButton;
class    IListBox;
class    IString;
class    IFrameWindow;
class    IContainerControl;
class    IContainerObject;
class    IToolBar;
class    IToolBarButton;
class    ISetCanvas;
class    ICanvas;
class    ISplitCanvas;
class    IProfile;
class    IMMWaveAudio;
class    IMMAmpMixer;
class    WAVE;

#include "auwmhdr.hpp"

//**********************************************************
//  Main Class definition                                 **
//**********************************************************

class AFNLogcWindow : public IFrameWindow,
                     public ICommandHandler,
                     public AUserMessageHandler
{
  public:
    AFNLogcWindow(unsigned long windowId);      //constructor
    ~AFNLogcWindow();                           //destructor

    void ASetCfgMenu(BOOL bFlag);
    void ASetPrMenu(BOOL bFlag);
    void AFillCnr();
    void AAddObject(char * oTitle);
    void AShuffleCnr(int iTimes);
    void getProfileData( );
    void announceWinner(IContainerObject *winObj);

  protected:
    Boolean command(ICommandEvent& cmdEvent);
    Boolean userMessage( IEvent& evt);

  private:
    ISplitCanvas     isCnv1,
                     isCnv2;
    ISetCanvas       isSet1;
    IMenuBar         menuBar;
    IProfile         rafProfile;
    IContainerControl cnr1, cnr2;
    IContainerObject  *svObj;

    IMMWaveAudio    *wavPlayer;
    IMMAmpMixer     *ampMixer;
    WAVE            *aWave;

    IToolBar         itTool1;
    IToolBarButton   itbOpen, itbSave, itbPrint;

    char             logfName[64];
    ofstream         logFile;
    BOOL             bCfgFlag;
    BOOL             bPrFlag;
    BOOL             bLogOpen;
    BOOL             bTbarFlag;
    int              iMixRpt, iWinRpt;
 };

