#include "mltwave.h"
#include <imcelcv.hpp>
#include <immwave.hpp>
#include <ifont.hpp>
#include <immttime.hpp>
#include <inotifev.hpp>
#include <icolor.hpp>
#include <ianimbut.hpp>
#include <icmdhdr.hpp>
#include <istattxt.hpp>
#include <iobservr.hpp>
#include <immplypn.hpp>
#include <immplyhd.hpp>
#include <ifiledlg.hpp>
#include <iradiobt.hpp>
#include <ipushbut.hpp>

class WaveHandler;
class WaveObserver;

class WAVE  : public IMMPlayerPanel {
//**************************************************************************
// Class:   WAVE                                                           *
//                                                                         *
// Purpose: Provide a Wave player.                                         *
//          It is a subclass of IMMPlayerPanel                             *
//                                                                         *
//**************************************************************************
public:

  WAVE( IMMWaveAudio*     wave,
        unsigned long     windowid,
        IWindow*          parent,
        IWindow*          owner,
        char*             pName,
        unsigned long     evtId);

  ~WAVE();

void stopRecording(const IMMPlayerPanel& panel);

IAnimatedButton
  *recordButton       () const;

/*------------------------------Filename ---------------------------*/
void getNextName(char *);
int  getCurIndex();

/*-------------------------------- Device --------------------------*/
IMMWaveAudio*
  wavePlayer          () const;

IStaticText
  name,
  readout;

IRadioButton
  lineIn,
  microphone;

IPushButton
  saveButton;

unsigned long doneEvtId;

private:
IMMWaveAudio
  *pWavePlayer;

IAnimatedButton
  loadit,
  *rec;

WaveHandler
  *handler;

WaveObserver
  *observer;

IMMTime    rMaxTime;

int iPerCt;
char pPath[64];

};

class WaveHandler : public IMMPlayerPanelHandler {
typedef IMMPlayerPanelHandler
  Inherited;
//**************************************************************************
// Class:   WaveHandler                                                    *
//                                                                         *
// Purpose: Provide a Handler for processing the load and record buttons   *
//                                                                         *
//**************************************************************************
public:

  WaveHandler ();

/*---------------------------- Event Dispatching -----------------------------*/
virtual Boolean
  command (ICommandEvent& event);

/*----------------------------- Event Processing -----------------------------*/
virtual Boolean
  stop               (const IMMPlayerPanel& panel);

};

class WaveObserver : public IObserver {
typedef IObserver
  Inherited;
//**************************************************************************
// Class:   WaveObserver                                                   *
//                                                                         *
// Purpose: Provide an Observer for processing the play notifications.     *
//                                                                         *
//**************************************************************************
public:

  WaveObserver (WAVE& wavePanel);

virtual WaveObserver
  &dispatchNotificationEvent(const INotificationEvent&);

private:
WAVE
  &panel;

};
